/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the PubSub Sidebar.
 *
 * The Initial Developer of the Original Code is
 * PubSub Concepts, Inc.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
//========================================================
//
// observer code for catching navigate complete events
//
//========================================================

function NavObserver(oContentWindow)
{
	this.m_oContentWindow = oContentWindow;
}

NavObserver.prototype.observe = function( oSubject, sMessage, sContextUrl )
{
	//window.dump(this.m_oContentWindow.document.location.href);

	var i = 0;
	try
	{
		// window is a chrome window; check its frames member
		for( i = 0; i< window.frames.length; i++)
		{
			loc = window.frames[i].location.toString();
			if( loc.match( /pubsubsidebar\/content\/sidebar.xul/ ))
			{
				// call the method on this document
				window.frames[i].loadEventFired( this.m_oContentWindow );
				
				// only one, presumably
				break;
			}
		}
		
	}
	catch( e )
	{
		// silent runtime // alert( "E: " + e );
	}

}

function ExampleInit()
{
	// Install our navigation observer so we can track the main client window.
	oContentWindow = window._content;

	if (oContentWindow) 
	{
		var oObserverService =
			Components.classes["@mozilla.org/observer-service;1"].getService();
		oObserverService =
			oObserverService.QueryInterface(Components.interfaces.nsIObserverService);
		oNavObserver = new NavObserver(oContentWindow);

		if (oObserverService && oNavObserver) 
		{
			oObserverService.addObserver(oNavObserver, "EndDocumentLoad", false);
		} 
		else 
		{
			oNavObserver = null;
			//alert("FAILURE to get observer service\n");
		}
	}
	else
	{
		//alert( "OCW is null" );
	}
}

addEventListener( "load", ExampleInit, false);
